Run unreferenced refunds

Note: To find out how to authorize your requests and handle errors, go to Before You Begin.

After you configure a device for Payroc Cloud, program your POS to use the Submit Refund Instruction method to send a refund instruction to the payment device.

To return funds to a cardholder, complete the following:

  1. Submit a refund instruction to the device.
  2. View the status of the refund instruction.
  3. View the details of the refund instruction.

You can also cancel a refund instruction if it hasn’t yet completed.

Before you begin

Bearer tokens

Use our Identity Service to generate a Bearer token to include in the header of your requests. To generate your Bearer token, complete the following steps:

  1. Include your API key in the x-api-key parameter in the header of a POST request.
  2. Send your request to https://identity.payroc.com/authorize.

Note: You need to generate a new Bearer token before the previous Bearer token expires.

Example request

$curl --location --request POST 'https://identity.payroc.com/authorize' --header 'x-api-key: <api key>'

Example response

If your request is successful, we return a response that contains your Bearer token, information about its scope, and when it expires.

1{
2 "access_token": "eyJhbGc....adQssw5c",
3 "expires_in": 3600,
4 "scope": "service_a service_b",
5 "token_type": "Bearer"
6}

Headers

To create the header of each POST request, you must include the following parameters:

  • Content-Type: Include application/json as the value for this parameter.
  • Authorization: Include your Bearer token in this parameter.
  • Idempotency-Key: Include a UUID v4 to make the request idempotent.
$curl
$-H "Content-Type: application/json"
$-H "Authorization: <Bearer token>"
$-H "Idempotency-Key: <UUID v4>"

Errors

If your request is unsuccessful, we return an error. For more information about errors, see Errors.

Step 1. Submit a refund instruction

To submit a refund instruction to a device, send a POST request to the Devices endpoint.

Request parameters

To create the body of your request, use the following parameters:

Request

processingTerminalIdstringRequired4-50 characters
Unique identifier that we assigned to the terminal.
orderobjectRequired
Object that contains information about the refund.
operatorstringOptional0-50 characters
Operator who initiated the request.
customerobjectOptional
Object that contains the customer's contact details and address information.
ipAddressobjectOptional
Object that contains the IP address of the device that sent the request.
customizationOptionsobjectOptional
Object that contains available options to customize certain aspects of an instruction.

Example request

POST
/v1/devices/:serialNumber/refund-instructions
1curl -X POST https://api.payroc.com/v1/devices/1850010868/refund-instructions \
2 -H "Idempotency-Key: 8e03978e-40d5-43e8-bc93-6894a57f9324" \
3 -H "Authorization: Bearer <token>" \
4 -H "Content-Type: application/json" \
5 -d '{
6 "processingTerminalId": "1234001",
7 "order": {
8 "orderId": "OrderRef6543",
9 "description": "Refund for order OrderRef6543",
10 "amount": 4999,
11 "currency": "USD"
12 },
13 "operator": "Jane",
14 "customizationOptions": {
15 "entryMethod": "manualEntry"
16 }
17}'

Response fields

If your request is successful, we send the refund instruction to the device.

Note: The response returns a value of inProgress for the status field and an identifier for the instruction that you can use to check the status of the instruction. To get a link to view the details of the refund, go to Step 2.

Response

statusenumRequired
Indicates the current status of the instruction. - `canceled` – The instruction was canceled before it was completed. - `completed` – The instruction has completed. Use the link object to check the resource. - `failure` – The instruction failed. Check the errorMessage field for more information. - `inProgress` – The instruction is currently in progress.
Allowed values:
refundInstructionIdstringRequired1-36 characters
Unique identifier that we assigned to the refund instruction.
errorMessagestringOptional
Description of the error that caused the instruction to fail. **Note:** We return this field only if the status is `failure`.

Example response

Response
1{
2 "status": "inProgress",
3 "refundInstructionId": "a37439165d134678a9100ebba3b29597",
4 "link": {
5 "rel": "self",
6 "method": "GET",
7 "href": "https://api.payroc.com/v1/refund-instructions/a37439165d134678a9100ebba3b29597"
8 }
9}

Step 2. View the status of a refund instruction

To check for updates to the status of the refund instruction, send a GET request to the Refund Instructions endpoint.

Before our gateway sends a response, it waits for up to a minute for the status of the instruction to change. We recommend that you keep the session open until the status of the instruction changes or the request times out.

If the status of the instruction doesn’t change, send another GET request. Our gateway waits up to a minute for the status of the instruction to change. Continue to send GET requests until the status changes.

Note: Wait until you receive a response from our gateway before you send another request.

Request parameters

To create your request, use the following parameters:

Path parameters

refundInstructionIdstringRequired1-36 characters
Unique identifier that we assigned to the refund instruction.

Example request

GET
/v1/refund-instructions/:refundInstructionId
1curl https://api.payroc.com/v1/refund-instructions/a37439165d134678a9100ebba3b29597 \
2 -H "Authorization: Bearer <token>"

Response fields

If your request is successful, we return the details of the refund instruction, including HATEOAS links to check the details of the refund. Use the HATEOAS links to get the refundId, which you need in Step 3.

If the status of the refund instruction is inProgress, our gateway waits up to a minute for the status to change before it returns a response.

Response

statusenumRequired
Indicates the current status of the instruction. - `canceled` – The instruction was canceled before it was completed. - `completed` – The instruction has completed. Use the link object to check the resource. - `failure` – The instruction failed. Check the errorMessage field for more information. - `inProgress` – The instruction is currently in progress.
Allowed values:
refundInstructionIdstringRequired1-36 characters
Unique identifier that we assigned to the refund instruction.
errorMessagestringOptional
Description of the error that caused the instruction to fail. **Note:** We return this field only if the status is `failure`.

Example response

Response
1{
2 "status": "completed",
3 "refundInstructionId": "a37439165d134678a9100ebba3b29597",
4 "link": {
5 "rel": "refund",
6 "method": "GET",
7 "href": "https://api.payroc.com/v1/refunds/CD3HN88U9F"
8 }
9}

Step 3. View the details of the refund

To check whether the processor approved or declined the refund, send a GET request to the Refunds endpoint.

Request parameters

To create your request, use the following parameters:

Path parameters

refundIdstringRequired=10 characters
Unique identifier that our gateway assigned to the refund.

Example request

GET
/v1/refunds/:refundId
1curl https://api.payroc.com/v1/refunds/CD3HN88U9F \
2 -H "Authorization: Bearer <token>"

Response fields

If your request is successful, we return the details of the refund.

Response

refundIdstringRequired=10 characters
Unique identifier that our gateway assigned to the refund.
processingTerminalIdstringRequired4-50 characters
Unique identifier that we assigned to the terminal.
orderobjectRequired
Object that contains information about the refund.
cardobjectRequired
Object that contains the details of the payment card.
transactionResultobjectRequired
Object that contains information about the transaction response details.
operatorstringOptional0-50 characters
Operator who requested the refund.
customerobjectOptional
Object that contains the customer's contact details and address information.
paymentobjectOptional
Object that contains information about a payment.
supportedOperationslist of enumsOptional
Array of operations that you can perform on the transaction. - `capture` - Capture the payment. - `refund` - Refund the payment. - `fullyReverse` - Fully reverse the transaction. - `partiallyReverse` - Partially reverse the payment. - `incrementAuthorization` - Increase the amount of the authorization. - `adjustTip` - Adjust the tip post-payment. - `addSignature` - Add a signature to the payment. - `setAsReady` - Set the transaction’s status to `ready`. - `setAsPending` - Set the transaction’s status to `pending`.
customFieldslist of objectsOptional
Array of customField objects.

Example response

Response
1{
2 "refundId": "CD3HN88U9F",
3 "processingTerminalId": "1234001",
4 "order": {
5 "orderId": "OrderRef6543",
6 "description": "Refund for order OrderRef6543",
7 "amount": 4999,
8 "currency": "USD",
9 "dateTime": "2024-07-02T15:30:00Z"
10 },
11 "card": {
12 "type": "Visa Credit",
13 "cardNumber": "453985******7062",
14 "expiryDate": "1230",
15 "entryMethod": "keyed"
16 },
17 "transactionResult": {
18 "status": "ready",
19 "responseCode": "A",
20 "type": "refund",
21 "approvalCode": "000000",
22 "authorizedAmount": -4999,
23 "currency": "USD",
24 "responseMessage": "OK5"
25 },
26 "customFields": [
27 {
28 "name": "yourCustomField",
29 "value": "abc123"
30 }
31 ]
32}

(Optional) Cancel a refund instruction

To cancel a refund instruction, send a DELETE request to the Refund Instructions endpoint.

Note: You can cancel a refund instruction only if its status is inProgress.

Request parameters

To create your request, use the following parameters:

Path parameters

refundInstructionIdstringRequired1-36 characters
Unique identifier that we assigned to the refund instruction.

Example request

Path parameters

refundInstructionIdstringRequired1-36 characters
Unique identifier that we assigned to the refund instruction.

Response

If your request is successful, we cancel the refund instruction.